\documentclass{report}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage{graphicx}
\usepackage[hidelinks]{hyperref}
\usepackage{enumitem}
\usepackage{fancyhdr}
\pagestyle{fancy}
\lhead{\textbf{System and device programming}}
\rhead{Laboratory 12}
\lfoot{Enrico Franco}
\rfoot{Politecnico di Torino}
\author{Enrico Franco}
\title{System and Device Programming \\
	Laboratory 12 - Exercise 1}
\begin{document}
\section*{Exercise 1}
First, it is needed to check that the number of arguments is correct. Otherwise the program will exit and return the value 1.

Each directory, i.e.,\@ server, has to guarantee the correct \emph{Readers \& Writers} behavior, exploiting critical sections, mutexes and storing the number of readers currently reading. Therefore, arrays of these structures are needed of dimension \texttt{NumberOfServers}, read from the input file.

After the allocation and initialization of such structures, it is possible to create \texttt{numberOfThreads} threads as indicated in the second parameter on the command line.

Each thread, simply extract three random numbers and proceed as indicated in the specification:
\begin{itemize}
\item A reader reads all the files in the extracted server and compute the total connection time;
\item A writer writes all the files in the extracted server and randomly generates a new date and a new connection time.
\end{itemize}
The main thread waits for the termination of all threads, closes handles and frees the dynamically allocated data structures.
\end{document}